#!/usr/bin/php -q
<?php  //utils-noc.inc.php  
//
// Nagios Fusion Operations Center API
//
// Copyright (c) 2011 Nagios Enterprises, LLC.  All rights reserved.
//  
// 

require_once(dirname(__FILE__).'/../../common.inc.php');

//make sure we don't last forever
ini_set('max_execution_time',grab_array_var($cfg,'default_timeout',60)); 

//$servers=get_servers(); 
//foreach($servers as $id => $val)
//	echo "ID: $id NAME: {$val['name']}\n"; 

//Don't run from web, don't run without an arg; 
if(!isset($argv) || !isset($argv[1]) || !isset($argv[2])) die("Unauthorized action\n"); 

//command line arguments ./nocfetch.php 
$type=$argv[1]; 
$sid=$argv[2];
$server=get_server_info($sid);

fetch_remote_noc_data($type,$sid); 

//done!


///////	FUNCTIONS ////////
function fetch_remote_noc_data($type,$sid) {
 
	//build the URL with credentials 
	$url = get_nagiosxi_backend_url($sid); 
	$r=0; 
	
	//echo "BASE: $url\n"; 
	
	if($type=='host') {
		$url = $url.'&'.noc_get_host_problems_url(); 
		$r=noc_host_data_fetch($url); 
	}	
		
	if($type=='service') {
		$url = $url.'&'.noc_get_service_problems_url(); 		 
		$r=noc_service_data_fetch($url);		
	}	
	
	echo "{$r} unhandled problems saved to DB \n"; 
	
	//if($r==0)
		//echo "URL: $url \n";

}


function noc_host_data_fetch($hosturl) {
	global $server; 
	global $cfg; 
	$timeout = grab_array_var($cfg,'default_timeout',60); 
	$r=0; 
	
	//echo "Fetching NOC host data: ".$server['name']."\n"; 
	$start = timer_start();

	//get data for the service
	$arr = get_server_data_from_url($hosturl,$timeout); 
	
	//log retrieval time
	$total_time=timer_stop($start); 
	echo $server['name'].": NOC Host Data retrieved in ".$total_time." seconds.\n";
		
	//once we have data, clear entries with this server ID 
	$xml = simplexml_load_string($arr['body']); 
	//echo "XML: \n"; 
	//print_r($xml);
	
	//flush data to table
	if($xml) {
		$r = noc_flush_host_xml_to_db($xml); 
	}
	else {
		echo "Unable to retrieve NOC host data from: ".$server['name']."\n"; 	
		file_put_contents('/usr/local/nagiosfusion/var/components/nocfail.log',print_r(explode("\n",$arr['body'],5),true),FILE_APPEND);
	}	
		
	return $r; 	

}

function noc_service_data_fetch($url) {
	global $server; 
	global $cfg; 
	$timeout = grab_array_var($cfg,'default_timeout',60); 
	$r=0; 
	
	//echo "Fetching NOC service data: ".$server['name']."\n"; 
	//monitor the retrieval time
	$start = timer_start(); 
	//echo "Start: $start\n"; 
	//get data for the service
	$arr = get_server_data_from_url($url,$timeout); 
	
	//print_r($arr); 
	
	//log retrieval time
	$total_time=timer_stop($start); 
	echo $server['name'].':NOC Service Data retrieved in '.$total_time.' seconds.'."\n";	
	
	//once we have data, clear entries with this server ID 

	$xml = simplexml_load_string($arr['body']); 
	//echo "XML: \n"; 
	//print_r($xml);
	
	//flush data to table
	if($xml) {
		$r = noc_flush_service_xml_to_db($xml); 
	}
	else {
		file_put_contents('/usr/local/nagiosfusion/var/components/nocfail.log',print_r(explode("\n",$arr['body'],5),true),FILE_APPEND);
		echo "Unable to retrieve NOC host data from: ".$server['name']."\n"; 
	}	

	return $r; 
}


/**
*	only accept valid XML object
*/ 
function noc_flush_service_xml_to_db($xml) {
	global $sid; 

	$problems=0;
	if(!$xml)  {
		echo "XML IS FALSE\n"; 
		return 0;

		}
	
	$query="DELETE FROM fusion_noc WHERE server_sid='{$sid}' AND type=1"; 
	exec_sql_query(DB_NAGIOSFUSION,$query,true);
	
	foreach($xml->servicestatus as $s) {
		
		//flush to DB 					
		$query = "INSERT INTO fusion_noc 
		(server_sid,type,host,service,status_update_time,status,output)
		VALUES ('{$sid}',1,'{$s->host_name}','{$s->name}','{$s->status_update_time}','{$s->current_state}','{$s->status_text}')";
				
		exec_sql_query(DB_NAGIOSFUSION,$query,true); 
		$problems++; 
	}	
	
	return $problems;
}

/**
*	only accept valid XML object
*/ 
function noc_flush_host_xml_to_db($xml) {
	global $sid; 

	$problems=0;
	if(!$xml) {
		echo "XML IS FALSE\n"; 
		return 0;
	}
	
	$query="DELETE FROM fusion_noc WHERE server_sid='{$sid}' AND type=0"; 
	exec_sql_query(DB_NAGIOSFUSION,$query,true);
	
	foreach($xml->hoststatus as $h) {
		
		//flush to DB 					
		$query = "INSERT INTO fusion_noc 
		(server_sid,type,host,service,status_update_time,status,output)
		VALUES ('{$sid}',0,'{$h->name}','','{$h->status_update_time}','{$h->current_state}','{$h->status_text}')";
				
		exec_sql_query(DB_NAGIOSFUSION,$query,true); 
		$problems++; 
	}	
	
	return $problems;
}


function noc_get_host_problems_url(){
	$backendargs["cmd"]="gethoststatus";
	$backendargs["current_state"]="in:1,2";
	$backendargs["has_been_checked"]=1;
	$backendargs["problem_acknowledged"]=0;
	$backendargs["scheduled_downtime_depth"]=0;
	$backendargs["orderby"]='last_state_change:d';
	$backendargs['is_active']=1;
	$backendargs['brevity']=3; 
	
	$args = http_build_query($backendargs);  
	return $args; 

}


function noc_get_service_problems_url(){	
	$backendargs["cmd"]="getservicestatus";
	$backendargs["combinedhost"]=1;
	$backendargs["current_state"]="in:1,2,3";
	$backendargs["has_been_checked"]=1;
	$backendargs["problem_acknowledged"]=0;
	$backendargs["scheduled_downtime_depth"]=0;
	$backendargs['is_active']=1;
	$backendargs['brevity']=3; 
	$backendargs["orderby"]='last_state_change:d';
	$backendargs['host_current_state']=0;
	
	$args = http_build_query($backendargs);  
	return $args; 
	
} //end function 



function timer_start() {
	$time = microtime();
	$time = explode(' ', $time);
	$time = $time[1] + $time[0];
	$start = $time;
	return $start; 
}

function timer_stop($start) {
	$time = microtime();
	$time = explode(' ', $time);
	$time = $time[1] + $time[0];
	$finish = $time;
	$total_time = round(($finish - $start), 4);
	return $total_time; 
}





?>